do--(start of non-destructive hook)

local Prefs = import('/lua/user/prefs.lua')
local options = Prefs.GetFromCurrentProfile('options')
local originalCreateUI = CreateUI
local originalOnSelectionChanged = OnSelectionChanged
local originalOnBeat = OnBeat
local selectionChange = false
local wasSquad = false
local oldSquad = false

local OldCreateUI = CreateUI
function CreateUI(isReplay)
    OldCreateUI(isReplay)
    if options.gui_massfab_manager ~= 0 then
    import("/mods/AlsComboPack/modules/massfabmanager.lua").Init()
    end
    if options.gui_massext_manager ~= 0 then
    import("/mods/AlsComboPack/modules/massextmanager.lua").Init()
    end
    if options.gui_advgrp_manager ~= 0 then
    import("/mods/AlsComboPack/modules/groupinterface.lua").Init()
    end
    if options.gui_scu_manager ~= 0 then
    import("/mods/AlsComboPack/modules/scumanager.lua").Init()
    end
end

function OnSelectionChanged(oldSelection, newSelection, added, removed)
	if not table.equal(newSelection, oldSelection) and import("/mods/AlsComboPack/modules/groupinterface.lua").AutoSelection then
		selectionChange = true
		if table.getn(oldSelection) > 0 then
			oldSquad = oldSelection[1].Squad
			wasSquad = true
			for i, oldUnit in oldSelection do
				if oldUnit.Squad == nil or oldUnit.Squad != oldSquad then
					wasSquad = false
				end
			end
		end
		if wasSquad then
			local subset = true
			for i, newUnit in newSelection do
				if newUnit.Squad == nil or newUnit.Squad != oldSquad then
					subset = false
				end
			end
			if subset then
				selectionChange = false
			end
		end
	end
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
    if newSelection 
     and table.getn(newSelection) == 1 
     and import("/mods/AlsComboPack/modules/selectedinfo.lua").SelectedOverlayOn then
         import("/mods/AlsComboPack/modules/selectedinfo.lua").ActivateSingleRangeOverlay()
    else
         import("/mods/AlsComboPack/modules/selectedinfo.lua").DeactivateSingleRangeOverlay()
    end   
end

function OnBeat()
	if selectionChange then
		import("/mods/AlsComboPack/modules/selectionsplit.lua").GroupChecker()
		selectionChange = false
	end
	wasSquad = false
	originalOnBeat()
end

import('/mods/AlsComboPack/modules/keymapping.lua').Init()

end --(end of non-destructive hook)