local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Group = import('/lua/maui/group.lua').Group
local GameMain = import('/lua/ui/game/gamemain.lua')
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox
local Button = import('/lua/maui/button.lua').Button
local Dragger = import('/lua/maui/dragger.lua').Dragger
local StatusBar = import('/lua/maui/statusbar.lua').StatusBar
local Prefs = import('/lua/user/prefs.lua')--preferences
local IntegerSlider = import('/lua/maui/slider.lua').IntegerSlider
local borders = import('/lua/ui/game/borders.lua').GetMapGroup()
local ToolTip = import('/lua/ui/game/tooltip.lua')
local EffectHelpers = import('/lua/maui/effecthelpers.lua')

local panel = false
local mouseover = false
local pToggle = false
local savedPrefs = Prefs.GetFromCurrentProfile("UIMassExtManager_settings")

local faxThread
local switchThread
local upgrdThread

local extList = {}
local ext2List = {}
local t1extlist = {}
local t2extlist = {}
local t3extlist = {}

local tmpicon = nil

local AutoUpdateExts = false
local meupgrading = false
local percentOnSlider = false
local totalExts = false
local totalOExts = false

local ExtOnStor = 0.75
local ExtOffStor = 0.95

local HelpText = {
	ExtOnStor = {
		Title = "On Storage",
		Body = "If mass stored is below ExtOnStor% then extractors will start turning on.",
	},
	ExtOffStor = {
		Title = "Off Storage",
		Body = "If mass stored is above ExtOffStor% then extractors will start turning off.",
	},
	AddBtn = {
		Title = "Add Extractors",
		Body = "Sets currently selected extractors to auto.",
	},
	RemoveBtn = {
		Title = "Remove Extractors",
		Body = "Disables auto on currently selected extractors.",
	},
	AddAllBtn = {
		Title = "Add All Extractors",
		Body = "Left Click: Sets all extractors to auto. Right Click: Automatically sets any new extractors to auto.",
	},
	OptionsBtn = {
		Title = "Options",
		Body = "Configure extractors auto behavior.",
	},
	Slider = {
		Title = "Extractors On",
		Body = "Shows what percentage of extractors are currently on.",
	},
	Slider = {
		Title = "Extractors On",
		Body = "Shows what percentage of extractors are currently on.",
	},
	totalExts = {
		Title = "Total Extractors",
		Body = "Shows the total number of extractors being monitored.",
	},
	meicons = {
		Title = "Mass Extractor Manager",
		Body = "Shows the total number of extractors. Press and hold to drag panel.",
	},
	AllowAutoStart = {
		Title = "Allow Auto On Start",
		Body = "Lets Mass Extractor Manager remember your last settings at start up.",
	},
	AllowExtToggle = {
		Title = "Allow Extractor Toggle",
		Body = "Lets Mass Extractor Manager toggle Extractors based on storage.",
	},
}

function GetFactionIcon()
  while tmpicon == nil do
	local bilist = GetSelectedUnits() or {}
    if bilist ~= nil then
      for i, unit in bilist do
        if unit:IsInCategory('AEON') then
        LOG("AEON")
          tmpicon = ('/mods/AlsComboPack/textures/UAB1302_build_btn.dds')
        elseif unit:IsInCategory('UEF') then
        LOG("UEF")
          tmpicon = ('/mods/AlsComboPack/textures/UEB1302_build_btn.dds')
        elseif unit:IsInCategory('CYBRAN') then
        LOG("CYBRAN")
          tmpicon = ('/mods/AlsComboPack/textures/URB1302_build_btn.dds')
        elseif unit:IsInCategory('SERAPHIM') then
        LOG("SERAPHIM")
          tmpicon = ('/mods/AlsComboPack/textures/XSB1302_build_btn.dds')
        end
      end
    else
      WaitSeconds(0.3)
    end
    WaitSeconds(0.3)
  end
	panel = CreatePanel(borders)
	Massextpanel = CreateExtControls(panel)
	pToggle = CreatePanelToggle(savedPrefs.Top)
	WaitSeconds(0.3)
	switchThread = ForkThread(SwitchExts)
end

function CreatePanel(parent)
	local panel = Bitmap(parent)
	panel:SetTexture('/mods/AlsComboPack/textures/panel.dds')
	panel.Depth:Set(100)
	panel.Height:Set(51)
  panel.Width:Set(90)
	if savedPrefs.Left < GetFrame(0).Right and savedPrefs.Top < GetFrame(0).Bottom then
		LayoutHelpers.AtLeftTopIn(panel, GetFrame(0), savedPrefs.Left, savedPrefs.Top)
	else
		LayoutHelpers.AtLeftTopIn(panel, GetFrame(0), savedPrefs.Left, savedPrefs.Top)
	end
	panel.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			local drag = Dragger()
			local offY = event.MouseY - self.Top()
			drag.OnMove = function(dragself, x, y)
				self.Top:Set(y - offY)
				self.Left:Set(function() return parent.Left() + 18 end)
				if self.Top() ~= panelToggle.Top() then
				panelToggle:Destroy()
				CreatePanelToggle(self.Top())
				end
				GetCursor():SetTexture(UIUtil.GetCursor('MOVE_WINDOW'))
			end
			drag.OnRelease = function(dragself)
				local tempPrefs = Prefs.GetFromCurrentProfile("UIMassExtManager_settings")
				tempPrefs.Left = self.Left()
				tempPrefs.Top = self.Top()
				Prefs.SetToCurrentProfile("UIMassExtManager_settings", tempPrefs)
				Prefs.SavePreferences()
				GetCursor():Reset()
				drag:Destroy()
			end
			PostDragger(self:GetRootFrame(), event.KeyCode, drag)
		elseif event.Type == 'MouseExit' then
			CloseToolTip()
		end
	end
	return panel
end

function CreatePanelToggle(yaxisoff)
	panelToggle = UIUtil.CreateCheckbox(borders, 
        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_up.dds'),
        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_up.dds'),
        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_over.dds'),
        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_over.dds'),
        UIUtil.UIFile('/game/avatar-tab-btn/tab-open_btn_dis.dds'),
        UIUtil.UIFile('/game/avatar-tab-btn/tab-close_btn_dis.dds'))
    LayoutHelpers.AtLeftTopIn(panelToggle, borders, 2, (yaxisoff))
  panelToggle.Height:Set(16)
	panelToggle.Depth:Set(100)
    panelToggle.OnCheck = function(self, checked)
        if checked then
			hideEffect(panel, Massextpanel)
		else
			showEffect(panel, Massextpanel)
		end
    end
	panelToggle.oldHandleEvent = panelToggle.HandleEvent
	panelToggle.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			CloseToolTip()
			if self:IsChecked() then
				CreateToolTip(self, {Title = "Minimize", Body = "Minimize the Mass Extractor panel."}, true)
			else
				CreateToolTip(self, {Title = "Maximize", Body = "Maximize the Mass Extractor panel."}, true)
			end
		elseif event.Type == 'MouseEnter' then
			if self:IsChecked() then
				CreateToolTip(self, {Title = "Maximize", Body = "Maximize the Mass Extractor panel."}, true)
			else
				CreateToolTip(self, {Title = "Minimize", Body = "Minimize the Mass Extractor panel."}, true)
			end
		elseif event.Type == 'MouseExit' then
			CloseToolTip()
		end
		panelToggle.oldHandleEvent(self, event)
	end
end

function CreateExtControls(parent)
  local extgroup = Group(parent)
	extgroup.Left:Set(parent.Left)
	extgroup.Top:Set(parent.Top)
	extgroup.Right:Set(parent.Right)
	extgroup.Bottom:Set(parent.Bottom)
	
	
    local AddExtButton = Button(extgroup, '/mods/AlsComboPack/textures/add_up.dds', '/mods/AlsComboPack/textures/add_down.dds', '/mods/AlsComboPack/textures/add_over.dds', '/mods/AlsComboPack/textures/add_up.dds', "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
    LayoutHelpers.AtLeftTopIn(AddExtButton, extgroup, 4, 13)
    local RemoveExtButton = Button(extgroup, '/mods/AlsComboPack/textures/remove_up.dds', '/mods/AlsComboPack/textures/remove_down.dds', '/mods/AlsComboPack/textures/remove_over.dds', '/mods/AlsComboPack/textures/remove_up.dds', "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
    LayoutHelpers.AtLeftTopIn(RemoveExtButton, extgroup, 22, 13)
    local AddAllExtsButton = Checkbox(extgroup, '/mods/AlsComboPack/textures/addall_up.dds', '/mods/AlsComboPack/textures/addall_down.dds', '/mods/AlsComboPack/textures/addall_over.dds', '/mods/AlsComboPack/textures/addall_over.dds', '/mods/AlsComboPack/textures/addall_up.dds', '/mods/AlsComboPack/textures/addall_up.dds', "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
    LayoutHelpers.AtLeftTopIn(AddAllExtsButton, extgroup, 4, 30)
    local OptionsButton = Button(extgroup, '/mods/AlsComboPack/textures/options_up.dds', '/mods/AlsComboPack/textures/options_down.dds', '/mods/AlsComboPack/textures/options_over.dds', '/mods/AlsComboPack/textures/options_up.dds', "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
    LayoutHelpers.AtLeftTopIn(OptionsButton, extgroup, 22, 30)

	  local mficon = Bitmap(extgroup, tmpicon)
    LayoutHelpers.AtLeftTopIn(mficon, extgroup, 41, 4)
    mficon.Height:Set(44)
    mficon.Width:Set(44)
	
	mficon.oldHandleEvent = mficon.HandleEvent
	mficon.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.meicons.Title, Body = HelpText.meicons.Body})
		end
		mficon.oldHandleEvent(self, event)
	end	

	totalOExts = UIUtil.CreateText(extgroup, "0", 18, UIUtil.bodyFont)
	LayoutHelpers.AtLeftTopIn(totalOExts, extgroup, 43, 4)
	totalOExts:SetColor('ffffffff')
	totalOExts:SetDropShadow(true)
  totalOExts.Depth:Set(function() return mficon.Depth() + 1 end)

	totalOExts.oldHandleEvent = totalOExts.HandleEvent
	totalOExts.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(self, {Title = "Total Extractors", Body = "Shows current total number of extractors."})
		end
		totalOExts.oldHandleEvent(self, event)
	end

	AddExtButton.oldHandleEvent = AddExtButton.HandleEvent
	AddExtButton.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			local selection = GetSelectedUnits() or {}
			for i, unit in selection do
				if unit:IsInCategory('MASSEXTRACTION') and unit:IsInCategory('STRUCTURE') then
					extList[unit:GetEntityId()] = unit
				end
			end
		elseif event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.AddBtn.Title, Body = HelpText.AddBtn.Body})
		end
		AddExtButton.oldHandleEvent(self, event)
	end

	RemoveExtButton.oldHandleEvent = RemoveExtButton.HandleEvent
	RemoveExtButton.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			local selection = GetSelectedUnits() or {}
			for i, unit in selection do
				if unit:IsInCategory('MASSEXTRACTION') and unit:IsInCategory('STRUCTURE') then
					extList[unit:GetEntityId()] = nil
				end
			end
		elseif event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.RemoveBtn.Title, Body = HelpText.RemoveBtn.Body})
		end
		RemoveExtButton.oldHandleEvent(self, event)
	end
	
	AddAllExtsButton.OnClick = function(self) end
	AddAllExtsButton.oldHandleEvent = AddAllExtsButton.HandleEvent
	AddAllExtsButton.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			if event.Modifiers.Left then
				local selection = GetSelectedUnits()
				local exlist = UISelectionByCategory("MASSEXTRACTION * STRUCTURE", false, false, false, false)
				local exlist = GetSelectedUnits() or {}
				for i, unit in exlist do
					extList[unit:GetEntityId()] = unit
				end
				SelectUnits(selection)
			else
				if self:IsChecked() then
          AutoUpdateExts = false
					self:SetCheck(false)
					savedPrefs.AddAllExtsButton = false
				else
          AutoUpdateExts = true
					self:SetCheck(true)
					savedPrefs.AddAllExtsButton = true
				end
      Prefs.SetToCurrentProfile("UIMassExtManager_settings", savedPrefs)
      Prefs.SavePreferences()
			end
		elseif event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.AddAllBtn.Title, Body = HelpText.AddAllBtn.Body})
		end
		AddAllExtsButton.oldHandleEvent(self, event)
	end

	if savedPrefs.AddAllExtsButton == true and savedPrefs.AllowAutoStart == true then
    AddAllExtsButton:SetCheck(true)
    AutoUpdateExts = true
	end

	OptionsButton.oldHandleEvent = OptionsButton.HandleEvent
	OptionsButton.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			OptionsPanel(extgroup)
		elseif event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.OptionsBtn.Title, Body = HelpText.OptionsBtn.Body})
		end
		OptionsButton.oldHandleEvent(self, event)
	end

	percentOnSlider = StatusBar(extgroup, 0, 1, false, false, '/mods/AlsComboPack/textures/slider_bg.dds', '/mods/AlsComboPack/textures/slider_fg.dds', false)
    LayoutHelpers.AtLeftTopIn(percentOnSlider, extgroup, 4, 3)
	percentOnSlider:SetMinimumSlidePercentage(4/29)
	percentOnSlider.oldHandleEvent = percentOnSlider.HandleEvent
	percentOnSlider.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.Slider.Title, Body = HelpText.Slider.Body})
		end
		percentOnSlider.oldHandleEvent(self, event)
	end
	
	totalExts = UIUtil.CreateText(extgroup, "0", 10, UIUtil.bodyFont)
	LayoutHelpers.AtLeftTopIn(totalExts, extgroup, 30, 1)
	totalExts.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(extgroup, {Title = HelpText.totalExts.Title, Body = HelpText.totalExts.Body})
		end
	end
		return extgroup
end

function CreateToolTip(control, data, togglebutton)
	if mouseover then mouseover:Destroy() mouseover = false end
	local text = data.Title
	local body = data.Body
	mouseover = ToolTip.CreateExtendedToolTip(control, text, body)
	mouseover.Top:Set(function() return panel.Top() + 2 end)
	mouseover.Left:Set(function() return panel.Right() + 1 end)
	mouseover:SetAlpha(0, true)
	mouseover:SetNeedsFrameUpdate(true)
	
	local delayTime = 0.5
	local totaltime = 0
	mouseover.OnFrame = function(self, deltaTime)
		if totaltime > delayTime then
			local alpha = self:GetAlpha() + (deltaTime * 4)
			if alpha < 1 then
				self:SetAlpha(alpha, true)
			else
				self:SetAlpha(1, true)
				self:SetNeedsFrameUpdate(false)
			end
		end
		totaltime = totaltime + deltaTime
	end
end
		
function CloseToolTip()
	if mouseover then mouseover:Destroy() mouseover = false end
end

function hideEffect(control, subcontrol1)
	control:DisableHitTest(true)
    control:SetNeedsFrameUpdate(true)

	local timefade = 0.1
	local time1 = 0.1
	local time2 = 0.2
	local minHeight = 16
  local timeAccum = 0
    
	EffectHelpers.FadeOut(subcontrol1, timefade)
	
    control.OnFrame = function(self, elapsedTime)
        timeAccum = timeAccum + elapsedTime
		if timeAccum >= (time1 + time2) then
            self:SetNeedsFrameUpdate(false)
            self:Hide()
			self.Right:Set(function() return self.Left() + 3 end)
		elseif timeAccum >= time1 then
			self.Right:Set(function() return self.Left() + self.BitmapWidth()*((time2+time1 - timeAccum)/(time2)) end)
			self.Bottom:Set(function() return self.Top() + minHeight end)
		else
			self.Bottom:Set(function() return self.Top() + minHeight + (self.BitmapHeight() - minHeight)*((time1 - timeAccum)/(time1)) end )
		end
    end
end

function showEffect(control, subcontrol1)
	control:Show()
    control:SetNeedsFrameUpdate(true)

	local timefade = 0.1
	local time1 = 0.2
	local time2 = 0.1
	local minHeight = 16
    local timeAccum = 0

    control.OnFrame = function(self, elapsedTime)
        timeAccum = timeAccum + elapsedTime
		if timeAccum >= (time1 + time2) then
			self:EnableHitTest(true)
            self:SetNeedsFrameUpdate(false)
			LayoutHelpers.ResetRight(self)
			LayoutHelpers.ResetBottom(self)
			EffectHelpers.FadeIn(subcontrol1, timefade)
		elseif timeAccum >= time1 then
			self.Bottom:Set(function() return self.Top() + minHeight + (self.BitmapHeight() - minHeight)*((timeAccum - time1)/(time2)) end )
			self.Right:Set(function() return self.Left() + self.BitmapWidth() end)
        else
			self.Right:Set(function() return self.Left() + self.BitmapWidth()*((timeAccum)/(time1)) end)
        end
    end
end

function cleanLists(tabList)
	for i, unit in (tabList) do
		if unit:IsDead() then
			(tabList)[i] = nil
		end
	end
end

Upgradeexts = function()
  meupgrading = true
		if table.getsize(extList) > 0 then
        for i, unit in extList do
					if unit:IsInCategory('TECH1') then
						t1extlist[i] = unit
					elseif unit:IsInCategory('TECH2') then
						t2extlist[i] = unit
					elseif unit:IsInCategory('TECH3') then						
						t3extlist[i] = unit
					end
        end
					if table.getsize(t1extlist) > 0 then
	          cleanLists(t1extlist)
						for i, unit in t1extlist do
              local selection = GetSelectedUnits()
              SelectUnits( { unit } )
              IssueBlueprintCommand("UNITCOMMAND_Upgrade", unit:GetBlueprint().General.UpgradesTo, 1, false)
              SelectUnits(selection)
                while not unit:IsDead() do
                  WaitSeconds(1)
                end
              break
 						end
					elseif table.getsize(t2extlist) > 0 then
					  cleanLists(t2extlist)
						for i, unit in t2extlist do
              local selection = GetSelectedUnits()
              SelectUnits( { unit } )
              IssueBlueprintCommand("UNITCOMMAND_Upgrade", unit:GetBlueprint().General.UpgradesTo, 1, false)
              SelectUnits(selection)
                while not unit:IsDead() do
                  WaitSeconds(1)
                end
              break
 						end
 					else
            WaitSeconds(12)
					end
		else
      WaitSeconds(6)		
		end
  meupgrading = false
end

SwitchExts = function()
	while true do
		local selection = GetSelectedUnits()
		if selection then
      WaitSeconds(0.3)
    else
      local ex2list = UISelectionByCategory("MASSEXTRACTION * STRUCTURE", false, false, false, false)
      local ex2list = GetSelectedUnits() or {}
      for i, unit in ex2list do
        if unit:IsDead() then
          ex2list[i] = nil
        else
          ext2List[unit:GetEntityId()] = unit
          if AutoUpdateExts then
            extList[unit:GetEntityId()] = unit
          end
        end
      end
      SelectUnits(selection)
		end
		
		cleanLists(ext2List)
		totalOExts:SetText(table.getsize(ext2List) or 0)
		
		cleanLists(extList)		
		totalExts:SetText(table.getsize(extList) or 0)

    if not meupgrading then
      upgrdThread = ForkThread(Upgradeexts)
    end

		if savedPrefs.AllowExtToggle == true and table.getsize(extList) > 0 then
      local econData = GetEconomyTotals()
      local MassStorageRatio = econData['stored']['MASS']/econData['maxStorage']['MASS']
      local MassTrend = (econData['income']['MASS'] - econData['lastUseActual']['MASS'])*10
      local MassStored = econData['stored']['MASS']
			if MassStorageRatio < 0.05 then
					for i, unit in extList do
					    if unit:IsDead() then
                extList[i] = nil
              else
                ToggleScriptBit({unit}, 4, true)
              end
					end
			else
				if MassStorageRatio > ExtOffStor and MassTrend > 0 then
					for i, unit in extList do
						if unit:IsDead() then
              extList[i] = nil
            else
                if not GetScriptBit({unit}, 4) then
                  ToggleScriptBit({unit}, 4, false)
                  WaitSeconds(0.6)
                  local econDataNew = GetEconomyTotals()
                  local MassTrendNew = (econDataNew['income']['MASS'] - econDataNew['lastUseActual']['MASS'])*10
                    if MassTrendNew < 0 then
                      break
                    end
                end
            end
					end
				elseif MassStorageRatio < ExtOnStor and MassTrend < 0 then
					for i, unit in extList do
						if unit:IsDead() then
              extList[i] = nil
            else
              if GetScriptBit({unit}, 4) then
								ToggleScriptBit({unit}, 4, true)
								WaitSeconds(0.6)
								local econDataNew = GetEconomyTotals()
								local MassTrendNew = (econDataNew['income']['MASS'] - econDataNew['lastUseActual']['MASS'])*10
								local MassStorageRationNew = econData['stored']['MASS']/econData['maxStorage']['MASS']
                  if MassTrendNew > 0 then
                    break
                  end
              end
            end
					end
				end
			end
			local totalOn = 0
				for i, unit in extList do
          if unit:IsDead() then
            extList[i] = nil
          else
            if not GetScriptBit({unit}, 4) then
              totalOn = totalOn + 1
            end
          end
        end
			percentOnSlider:SetValue(totalOn/table.getsize(extList))
		end
		WaitSeconds(2)
	end
end

function Init()
	if not savedPrefs then
		savedPrefs = {
			Left = 18,
			Top = 450,
			ExtOnStor = 0.75,
			ExtOffStor = 0.95,
			AddAllExtsButton = false,
			AllowAutoStart = false,
			AllowExtToggle = true,
		}
		Prefs.SetToCurrentProfile("UIMassExtManager_settings", savedPrefs)
		Prefs.SavePreferences()
	else
		ExtOnStor = savedPrefs.ExtOnStor
		ExtOffStor = savedPrefs.ExtOffStor
	end
	
	faxThread = ForkThread(GetFactionIcon)
	
end

function OptionsPanel(parent)
	local window = Bitmap(parent)
	window:SetTexture('/mods/AlsComboPack/textures/configwindow.dds')
	LayoutHelpers.AtLeftTopIn(window, parent)
	window.Depth:Set(function() return parent.Depth() + 10 end)

	local AutoStarttitle = UIUtil.CreateText(window, "AutoStart", 14, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(AutoStarttitle, window, 25, 6)
	AutoStarttitle.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(parent, {Title = HelpText.AllowAutoStart.Title, Body = HelpText.AllowAutoStart.Body})
		end
	end
  local AllowAutoStart = Checkbox(window,
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    '/mods/AlsComboPack/textures/splitbtn_down.dds',
    '/mods/AlsComboPack/textures/splitbtn_over.dds',
    '/mods/AlsComboPack/textures/splitbtn_over.dds',
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
  LayoutHelpers.AtLeftTopIn(AllowAutoStart, window, 5, 6)
	AllowAutoStart.title = UIUtil.CreateText(AllowAutoStart, "X", 10)
	AllowAutoStart.title:SetColor('338833')
	LayoutHelpers.AtCenterIn(AllowAutoStart.title, AllowAutoStart, 2, 1)
	AllowAutoStart.OnClick = function(self) end
	AllowAutoStart.oldHandleEvent = AllowAutoStart.HandleEvent
	AllowAutoStart.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			if event.Modifiers.Left then
				if self:IsChecked() then
					self:SetCheck(false)
					AllowAutoStart.title:SetColor('e61b1b')
					savedPrefs.AllowAutoStart = false
				else
					self:SetCheck(true)
					AllowAutoStart.title:SetColor('2ec74d')
					savedPrefs.AllowAutoStart = true
				end
			end
		end
		AllowAutoStart.oldHandleEvent(self, event)
	end
	
	if savedPrefs.AllowAutoStart == true then
    AllowAutoStart:SetCheck(true)
    AllowAutoStart.title:SetColor('2ec74d')
  else
    AllowAutoStart:SetCheck(false)
    AllowAutoStart.title:SetColor('e61b1b')
	end

	local AutoToggletitle = UIUtil.CreateText(window, "AutoToggle", 14, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(AutoToggletitle, window, 25, 29)
	AutoToggletitle.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(parent, {Title = HelpText.AllowExtToggle.Title, Body = HelpText.AllowExtToggle.Body})
		end
	end
  local AllowExtToggle = Checkbox(window,
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    '/mods/AlsComboPack/textures/splitbtn_down.dds',
    '/mods/AlsComboPack/textures/splitbtn_over.dds',
    '/mods/AlsComboPack/textures/splitbtn_over.dds',
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    '/mods/AlsComboPack/textures/splitbtn_up.dds',
    "UI_Menu_MouseDown_Sml", "UI_Menu_MouseDown_Sml")
  LayoutHelpers.AtLeftTopIn(AllowExtToggle, window, 5, 29)
	AllowExtToggle.title = UIUtil.CreateText(AllowExtToggle, "X", 10)
	AllowExtToggle.title:SetColor('338833')
	LayoutHelpers.AtCenterIn(AllowExtToggle.title, AllowExtToggle, 2, 1)
	AllowExtToggle.OnClick = function(self) end
	AllowExtToggle.oldHandleEvent = AllowExtToggle.HandleEvent
	AllowExtToggle.HandleEvent = function(self, event)
		if event.Type == 'ButtonPress' then
			if event.Modifiers.Left then
				if self:IsChecked() then
					self:SetCheck(false)
					AllowExtToggle.title:SetColor('e61b1b')
					savedPrefs.AllowExtToggle = false
				else
					self:SetCheck(true)
					AllowExtToggle.title:SetColor('2ec74d')
					savedPrefs.AllowExtToggle = true
				end
			end
		end
		AllowExtToggle.oldHandleEvent(self, event)
	end
	
	if savedPrefs.AllowExtToggle == true then
    AllowExtToggle:SetCheck(true)
    AllowExtToggle.title:SetColor('2ec74d')
  else
    AllowExtToggle:SetCheck(false)
    AllowExtToggle.title:SetColor('e61b1b')
	end

	CreateOptionsSlider(window, "ExtOnStor", 5, 52, 100)
	CreateOptionsSlider(window, "ExtOffStor", 5, 75, 100)
	
	local okButton = UIUtil.CreateButtonStd(window, '/widgets/small', 'OK', 16)
	LayoutHelpers.AtLeftTopIn(okButton, window, 160, 103)
	okButton.OnClick = function(self)
		Prefs.SetToCurrentProfile("UIMassExtManager_settings", savedPrefs)
		Prefs.SavePreferences()
		window:Destroy()
	end
	
	local cancelButton = UIUtil.CreateButtonStd(window, '/widgets/small', 'Cancel', 16)
	LayoutHelpers.AtLeftTopIn(cancelButton, window, 8, 103)
	cancelButton.OnClick = function(self)
		window:Destroy()
	end
end

function CreateOptionsSlider(parent, option, left, top, dividefactor)
	local title = UIUtil.CreateText(parent, option, 14, UIUtil.titleFont)
	LayoutHelpers.AtLeftTopIn(title, parent, left, top)
	title.HandleEvent = function(self, event)
		if event.Type == 'MouseEnter' then
			CreateToolTip(parent, {Title = HelpText[option].Title, Body = HelpText[option].Body})
		end
	end
	local slider = IntegerSlider(parent, false, 0,100, 1, UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'), UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'), UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), UIUtil.SkinnableFile('/slider02/slider-back_bmp.dds'))  
	LayoutHelpers.AtLeftTopIn(slider, parent, left + 85, top)
	local value = UIUtil.CreateText(parent, "0", 14, UIUtil.bodyFont)
	LayoutHelpers.RightOf(value, slider)
	slider:SetValue(savedPrefs[option]*dividefactor)
	value:SetText(math.floor(savedPrefs[option]*dividefactor+0.5))
	slider.OnValueChanged = function(self, newValue)
		savedPrefs[option] = newValue/dividefactor
		value:SetText(newValue)
	end
end